'frmOutput.inc
Global OutputHdlr() As MessageHandler


Function fnOutputProc_OnCreate(Wea As WndEventArgs) As Long
  Local ptrBox As CBox Ptr, ptrOutputBox As CBox Ptr
  Local pCreateStruct As CREATESTRUCT Ptr
  
  pCreateStruct=Wea.lParam
  ptrBox=@pCreateStruct.lpCreateParams
  ptrOutputBox=GlobalAlloc(%GPTR,SizeOf(CBox))
  If ptrOutputBox Then
     Type Set @ptrOutputBox = @ptrBox 
     Call SetProp(Wea.hWnd,"Our Box",ptrOutputBox) 
  Else
     Function=-1   
  End If  

  Function=0
End Function


Function fnOutputProc_OnPaint(Wea As WndEventArgs) As Long
  Local szBuffer As Asciiz*64
  Local strField As String*8
  Local hFont,hTmp As Dword
  Local ptrBox As CBox Ptr
  Local ps As PAINTSTRUCT
  Local hDC As Dword
  
  hDC=BeginPaint(Wea.hWnd,ps)
  hFont=CreateFont _
  ( _
    20,0,0,0,%FW_BOLD,0,0,0,%ANSI_CHARSET, _
    %OUT_DEFAULT_PRECIS,%CLIP_DEFAULT_PRECIS, _
    %PROOF_QUALITY,%DEFAULT_PITCH,"Courier New" _
  )
  hTmp=SelectObject(hDC,hFont)
  ptrBox=GetProp(Wea.hWnd,"Our Box")
  szBuffer="Box Type     = " & @ptrBox.szBoxType
  TextOut(hDC,40,20,szBuffer,Len(szBuffer))
  RSet strField=Format$(@ptrBox.dblLength,"###0.#0")
  szBuffer="Length       = " & strField
  TextOut(hDC,40,40,szBuffer,Len(szBuffer))
  RSet strField=Format$(@ptrBox.dblWidth,"###0.#0")
  szBuffer="Width        = " & strField
  TextOut(hDC,40,60,szBuffer,Len(szBuffer))
  RSet strField=Format$(@ptrBox.dblHeight,"###0.#0")
  szBuffer="Height       = " & strField
  TextOut(hDC,40,80,szBuffer,Len(szBuffer))
  RSet strField=Format$(@ptrBox.dblVolume,"####0.#0")
  szBuffer="Volume       = " & strField
  TextOut(hDC,40,100,szBuffer,Len(szBuffer))
  Call SelectObject(hDC,hTmp) 
  Call DeleteObject(hFont)
  Call EndPaint(Wea.hWnd,ps)
  
  fnOutputProc_OnPaint=0
End Function


Function fnOutputProc_OnClose(Wea As WndEventArgs) As Long
  Local pBox As CBox Ptr
  
  pBox=RemoveProp(Wea.hWnd,"Our Box")
  If pBox Then
     Call GlobalFree(pBox)
  End If       
  Call DestroyWindow(Wea.hWnd)
  
  fnOutputProc_OnClose=0
End Function


Function fnOutputProc(ByVal hWnd As Long,ByVal wMsg As Long,ByVal wParam As Long,ByVal lParam As Long) As Long
  Static Wea As WndEventArgs
  Register iReturn As Long
  Register i As Long

  For i=0 To 2
    If wMsg=OutputHdlr(i).wMessage Then
       Wea.hWnd=hWnd: Wea.wParam=wParam: Wea.lParam=lParam
       Call Dword OutputHdlr(i).dwFnPtr Using FnPtr(Wea) To iReturn
       fnOutputProc=iReturn
       Exit Function
    End If
  Next i

  fnOutputProc=DefWindowProc(hWnd,wMsg,wParam,lParam)
End Function
